<template>
    <v-row>
        <v-col>
            <v-card>
                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                    <v-container class="px-8">
                        <v-row class="pb-2">
                            <v-col cols="4" md="4" class="align-self-center flex-grow-1 flex-shrink-0">
                                <div class="title text--primary fill-height">
                                    {{ $t(mode + '_', [$tc('pick', 1)]) }}
                                </div>
                            </v-col>

                            <v-spacer></v-spacer>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('pick_', [$t('info')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('name') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                    <v-text-field
                                        v-model="localValue.user.profile.name"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$t('name')])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('email') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="email" rules="required">
                                    <v-text-field
                                        v-model="localValue.user.email"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$t('email')])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label font-black">{{ $t('phone') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="phone" rules="required">
                                    <v-text-field
                                        v-model="localValue.user.profile.mobile"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$t('phone')])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('gender', 1) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="gender" rules="required">
                                    <v-text-field
                                        v-model="localValue.gender.name"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('gender', 1)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('size', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="sizes" rules="required">
                                    <v-text-field
                                        v-model="localValue.sizes"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('size', 2)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('style', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="styles" rules="required">
                                    <v-text-field
                                        v-model="localValue.styles"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('style', 2)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('fit', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="fits" rules="required">
                                    <v-text-field
                                        v-model="localValue.fits"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('fit', 2)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('brand', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="brands" rules="required">
                                    <v-text-field
                                        v-model="localValue.brands"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('brand', 2)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('color', 2) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="colors" rules="required">
                                    <v-text-field
                                        v-model="localValue.colors"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$tc('color', 2)])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('status') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="status" rules="required">
                                    <v-text-field
                                        v-model="localValue.status"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_', [$t('status')])"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('pick_at') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="created_at" rules="required">
                                    <v-text-field
                                        v-model="localValue.created_at"
                                        :error-messages="errors"
                                        :placeholder="$t('pick_at')"
                                        outlined
                                        disabled
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $tc('remark') }}</div>
                                <ValidationProvider v-slot="{ errors }" :name="$tc('remark', 1)">
                                    <v-text-field
                                        v-model="localValue.remark"
                                        :error-messages="errors"
                                        :placeholder="$tc('remark', 1)"
                                        outlined
                                    >
                                        <template v-slot:append>
                                            <v-btn
                                                depressed
                                                tile
                                                color="primary"
                                                class="ma-0 mb-4"
                                                @click="saveRemark">
                                                {{ $t('save') }}
                                            </v-btn>
                                        </template>
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-divider class="py-2"></v-divider>

                        <v-row class="pt-5">
                            <v-col class="text-center">
                                <v-btn
                                    class="text--white mx-2"
                                    color="warning"
                                    :loading="submit"
                                    @click="pending"
                                    large
                                >
                                    <v-icon>mdi-check</v-icon>
                                    {{ $t('pending') }}
                                </v-btn>
                                <v-btn
                                    class="text--white mx-2"
                                    color="primary"
                                    :loading="submit"
                                    @click="attended"
                                    large
                                >
                                    <v-icon>mdi-check</v-icon>
                                    {{ $t('attended') }}
                                </v-btn>

                                <v-btn
                                    class="text--white mx-2"
                                    color="success"
                                    :loading="submit"
                                    @click="close"
                                    large
                                >
                                    <v-icon>mdi-check</v-icon>
                                    {{ $t('close') }}
                                </v-btn>

                                <v-btn
                                    class="text--white mx-2"
                                    color="error"
                                    :loading="submit"
                                    @click="reject"
                                    large
                                >
                                    <v-icon>mdi-close</v-icon>
                                    {{ $t('reject') }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </ValidationObserver>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import util from "../../../mixins/util"
    import TextEditor from "../editor/TextEditor";
    import { mapMutations } from "vuex";

    export default {
        name: "PickForm",
        components: {
            TextEditor,
            ValidationObserver,
            ValidationProvider
        },
        mixins: [ util ],

        props: {
            loading: {
                type: Boolean,
                default: false,
            },
            value: {
                type: Object,
                required: true
            },
            clearable: {
                type: Boolean,
                default: true
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            }
        },

        data: () => ({
            submit: false,
        }),

        computed: {
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            attended() {
                axios.put(`api/picks/${this.value.id}/attended`)
                    .then(({ data }) => {
                        if(data.status === 'attended') {
                            this.success(this.$t('pick_action.attended'));
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.$router.push('/pick');
                    });
            },

            pending() {
                axios.put(`api/picks/${this.value.id}/pending`)
                    .then(({ data }) => {
                        if(data.status === 'pending') {
                            this.success(this.$t('pick_action.pending'));
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.$router.push('/pick');
                    });
            },

            close() {
                axios.put(`api/picks/${this.value.id}/close`)
                    .then(({ data }) => {
                        if(data.status === 'close') {
                            this.success(this.$t('pick_action.close'));
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.$router.push('/pick');
                    });
            },

            reject() {
                axios.put(`api/picks/${this.value.id}/reject`)
                    .then(({ data }) => {
                        if(data.status === 'rejected') {
                            this.success(this.$t('pick_action.rejected'));
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.$router.push('/pick');
                    });
            },

            saveRemark() {
                axios.put(`api/picks/${this.value.id}`,{
                    'remark': this.localValue.remark
                })
                    .then(() => {
                        this.success(this.$t('pick_action.remark.save'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
            },

            prepareData() {
                let data = { ...this.localValue };

                return this.objectToFormData(data);
            },
        }
    }
</script>

<style scoped>
    .toggle.v-input--selection-controls {
        margin-top: 0 !important;
    }

</style>
